/**
 * Title: UserTabPanel.java
 * Copyright:   Copyright (c) 2002
 * Company:
 * @author  Kenneth J. Pouncey
 * @version 0.5
 *
 * Description:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */
/*
 *  Modified MAY/2005 By pei
 */
package je.tn5250j.spoolfile;

import java.awt.event.*;
import javax.swing.*;

import je.tn5250j.tools.AlignLayout;
import je.tn5250j.event.ToggleDocumentListener;
import je.tn5250j.gui.ToggleDocument;

public class UserTabPanel extends JPanel implements QueueFilterInterface,
                                                         ToggleDocumentListener {

   JRadioButton all;
   JRadioButton select;
   JTextField user;;

   public UserTabPanel() {
      try {
         jbInit();
      }
      catch(Exception ex) {
         ex.printStackTrace();
      }
   }

   void jbInit() throws Exception {

      setLayout(new AlignLayout(2,5,5));

      all = new JRadioButton("All");

      all.setSelected(false);

      select = new JRadioButton("User");
      select.setSelected(true);
      select.addItemListener(new java.awt.event.ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            select_itemStateChanged(e);
         }
      });

      user = new JTextField("*CURRENT",15);
      ToggleDocument td = new ToggleDocument();
      td.addToggleDocumentListener(this);
      user.setDocument(td);
      user.setText("*CURRENT");

      ButtonGroup bg = new ButtonGroup();
      bg.add(all);
      bg.add(select);

      add(all);
      add(new JLabel(""));
      add(select);
      add(user);

      setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

   }

   /**
    * Reset to default value(s)
    */
   public void reset() {

//      user.setEnabled(true);
      user.setText("*CURRENT");
      select.setSelected(true);

   }

   void select_itemStateChanged(ItemEvent e) {
//      if (select.isSelected())
//         user.setEnabled(true);
//      else
//         user.setEnabled(false);
   }

   public void toggleNotEmpty() {

      select.setSelected(true);

   }

   public void toggleEmpty() {

   }

   public String getUser() {
      if (all.isSelected())
         return "*ALL";
      else
         return user.getText().trim();
   }

   public void setUser(String filter) {

      user.setText(filter);
   }
}